# Autor Torsten Muecker 1985-2001
# Maschinencode des PC-Assemblers fuer PC1403
# wird am Ende des Vektors V$(182)*5 plaziert,
# der auch die Mnemotabelle enthaelt

# Suchen eines Mnemos in der Mnemotabelle
# zeitkritisch, deshalb als als MC
# fuer Assemblerroutine ","

		ORG	64160				# nach V$(159)
Y$1		EQU	&FB19				# 1. String-Char in Y$ nach &F5
ERGEBNIS	EQU	&FB0E				# 2 DB vor Bgn Std.Var

ASMV$H	EQU	&F7				# Zeiger Bgn Mnemotabelle-1
ASMV$L	EQU	&7C				# zeigt auf Chr-Laenge V$(*)

							# Code-Beginn gegen PC1401
		LIQ	2				# um 2 Byte vorgezogen
		LIA	ASMV$L			# ROM-Aufruf wurde entfernt
		LIB	ASMV$H
		LP 4				
		MVB					# LD X,BA (Mnemotab)
		MVB					# LD Y,X
		LIA	&9F				# LD K,Anzahl der Mnemos-1
		EXAM
		INCP
		LIDP	Y$1				# Vergleichbasis
		LII	4				# maximale Mnemolaenge-1
		MVWD					# L...RegD
ASMBGN1:	LIB	5				# maximale Mnemolaenge
		LP 8					# @ K
ASMBGN2:	INCP					# aktuelles Zeichen
		DECB
		JRCP	ASMEXT			# Mnemo 5 Zeichen gefunden
		IXL
		CPIA	0				# Weitere Zeichen im Mnemo?
		JRNZP	ASMPOS1
		CPIM	&41				# w. Zeichen ab "A" in Vgl.-Basis?
		JRCP	ASMEXT			# gefunden
ASMPOS1:	CPMA
		JRZM	ASMBGN2			# naechstes Zeichen
		DX
		EXAB
		PUSH					# zum nachsten Mnemo
ASMPOS2:	IX
ASMLOP1:	LOOP	ASMLOP1-ASMPOS2+1
		DECK					# Aeusseres Schleifenende
		JRNCM	ASMBGN1
		LIQ	4				# nicht vorh = Syntaxfehler
		JRP	ASMEXT2
ASMEXT:	LIQ	6				# gefunden
ASMEXT2:	LP 2
		MVB
		SBB					# Differenz berechnen
		LP 4
		LIDP	ERGEBNIS
		EXBD
		RTN

# Suchen einer Bytefolge im RAM
# fuer "A" oder "C"-Programm
		LIDP	ASMSRCBGN
		LP 4					# @X
		MVBD					# Suchanfang laden
		LP 8					# Funktion? XH/ZZhl-> K/L
		MVBD					# INC DP
		LP 0					# @I
		MVMD					# Zeichenanzahl laden
		LP 9					# @L-> Zeichenzahl
		MVWD					# Suchfolge Reg&A...Reg&12
		DECL					# setze Schleifenzaehler
		LP 9
		LDM
ASMPOS3:	PUSH					# Suchschleife
ASMPOS4:	INCP
		IXL
		CPMA
		JRZP	ASMLOP2			# Byte stimmt ueberein
		POP					# Schleife abbrechen
		LP 9					
ASMPOS5:	CPMA
		JRZM	ASMPOS3			# Wenn nicht 1. Zeichen
		INCA					# Akku rekonstruieren
		DX					# Adresszeiger auf 1.Z.
		JRM	ASMPOS5
ASMLOP2:	LOOP	ASMLOP2-ASMPOS4+1		# naechstes Byte
		LIDP	ASMSRCBGN
		LP 4
		EXBD
		RTN
ASMSRCBGN:	DW	&1FFF				# ^Suchanfang-1
ASMSRCCNT:	DB	9				# Zeichenanzahl
ASMSRCSTR:	DS	"123456789"			# Suchfolge
		DB	0				# Funktion?
